#include "StdAfx.h"
#include "LanComm.h"
#include "ListenSocket.h"
#include "ServiceSocket.h"
#include "cxcore.h"
#include "cv.h"
#include "highgui.h"
#include "andordll.h"


LanComm::LanComm(void)
{
	m_bufsize=32;
}

LanComm::~LanComm(void)
{
	m_pListenSocket->Close();
	m_pServiceSocket->Close();
	delete m_pListenSocket;
	delete m_pServiceSocket;

}

void LanComm::ProcessAccept(void)
{
	m_pServiceSocket = new CServiceSocket();
	m_pServiceSocket->InitCServiceSocket(this);
	m_pListenSocket->Accept(*m_pServiceSocket);
}


void LanComm::ProcessReceive(CServiceSocket * pServiceSocket)
{
	int nRead;
	TCHAR strRecvBuffer[128];
	CString MsgFromMainCom=_T("");
	int * intRecvBuffer;
	int acquisition, temp, gain, hBin, vBin, shutter, fan, nFrame;
	float exptime;
	int retval;
	
	nRead=pServiceSocket->Receive(strRecvBuffer,m_bufsize*sizeof(int));
	

	// ŵǾٸ, 
	intRecvBuffer=(int *)strRecvBuffer;
	
	//MsgFromMainCom.Format(_T("In_Msg:%d, %d, %d, %d, %d"), intRecvBuffer[0], intRecvBuffer[1],
	//					intRecvBuffer[2], intRecvBuffer[3], intRecvBuffer[4]);
	//pprintEdit->InsertString(-1, MsgFromMainCom);
	//pprintEdit->SetCurSel(pprintEdit->GetCount()-1);

	if(*intRecvBuffer==12455){//change buf size
		m_bufsize=*(intRecvBuffer+1);
	}
	else if(*intRecvBuffer==12456){//Initialize
		retval=pCCDcontrol->InitAndor(1,0,0,1,2,0.001f,1,0);
		SndMsg[0]=12456;
		SndMsg[1]=retval;
		SndMsg[2]=pCCDcontrol->m_xpixels;
		SndMsg[3]=pCCDcontrol->m_ypixels;	
		OnSend(SndMsg);
		
	}

	else if(*intRecvBuffer==12457){//Setparameter 12457
		SndMsg[0]=12457;
		SndMsg[1]=1;
		OnSend(SndMsg);
		acquisition		=	*(intRecvBuffer+1);
		temp			=	*(intRecvBuffer+2);
		gain			=	*(intRecvBuffer+3);
		hBin			=	*(intRecvBuffer+4);
		vBin			=	*(intRecvBuffer+5);
		exptime			=	0.001f*((float)(*(intRecvBuffer+6)));
		shutter			=	*(intRecvBuffer+7);
		fan				=	*(intRecvBuffer+8);
		nFrame			=	*(intRecvBuffer+9);
		
		pCCDcontrol->Setting(acquisition, temp, gain, hBin,vBin, exptime, shutter, fan);
		pCCDcontrol->m_nFrame		=	nFrame;
		MsgFromMainCom.Format( _T("acquisition : %d, temp : %d, gain : %d, hBin : %d, vBin : %d, /n exptime : %f, shutter : %d, fan : %d, nFrame : %d"), 
			acquisition, temp, gain, hBin, vBin, exptime, shutter, fan, nFrame);
		pprintEdit->InsertString(-1, MsgFromMainCom);
		
	}
	else if(*intRecvBuffer==12458){
		
		pCCDcontrol->m_nFrame		=	1;
		int errorValue=pCCDcontrol->GrabImage();
		SndMsg[0]=12458;
		SndMsg[2]=errorValue;
		OnSend(SndMsg);
		
	}

	else if(*intRecvBuffer==12460){
		int num=*(intRecvBuffer+1);
		char * charRecvBuffer=(char * ) intRecvBuffer;
		
		char time1[50];
		char time2[50];
		sprintf(time1, charRecvBuffer+8);
		sprintf(time2, charRecvBuffer+58);
		float * difftime2=(float *)(charRecvBuffer+108);
		SndMsg[0]=12460;
		SndMsg[1]=m_nFrameNumber;
		OnSend(SndMsg);
		pCCDcontrol->GrabnFrame(m_nFrameNumber);

		MsgFromMainCom.Format(_T("%d's image grab"), m_nFrameNumber);
		pprintEdit->InsertString(-1, MsgFromMainCom);
		pprintEdit->SetCurSel(pprintEdit->GetCount()-1);
		
	}
	else if(*intRecvBuffer==12461){//GetAvailableCamera Check
		pCCDcontrol->LanGetAvailableCameras();
		SndMsg[0]=12461;
		SndMsg[1]=pCCDcontrol->m_totalCameras;
		
		OnSend(SndMsg);
		MsgFromMainCom.Format(_T("%d cameras set in the system."), SndMsg[1]);
		pprintEdit->InsertString(-1, MsgFromMainCom);
		pprintEdit->SetCurSel(pprintEdit->GetCount()-1);
	}
	else if(*intRecvBuffer==12462){//TakeBiasDark
		pCCDcontrol->TakeBiasDark();
		SndMsg[0]=12462;
		OnSend(SndMsg);
		MsgFromMainCom.Format(_T("BiasDark image is Taken."));
		pprintEdit->InsertString(-1, MsgFromMainCom);
		pprintEdit->SetCurSel(pprintEdit->GetCount()-1);
	}
	else if(*intRecvBuffer==12463){//SettingFirstPart
		int ccd_camera	=	*(intRecvBuffer+1);
		int ringvalue	=	*(intRecvBuffer+2);
		int ccd_Read	=	*(intRecvBuffer+3);
		int ccd_Trigger	=	*(intRecvBuffer+4);

		SndMsg[0]=12463;
		OnSend(SndMsg);
		pCCDcontrol->SetOkButton_FirstPart(ccd_camera, ringvalue, pCCDcontrol->m_acquisition,
						   ccd_Read,  ccd_Trigger, pCCDcontrol->m_gain, 
						   pCCDcontrol->m_hBin, pCCDcontrol->m_vBin, 
						   pCCDcontrol->m_exptime, pCCDcontrol->m_shutter,
						   pCCDcontrol->m_fan, pCCDcontrol->m_nFrame);
		MsgFromMainCom.Format(_T("SetOkButton_FirstPart."));
		pprintEdit->InsertString(-1, MsgFromMainCom);
		pprintEdit->SetCurSel(pprintEdit->GetCount()-1);
	}
	else if(*intRecvBuffer==12464){//AllocFlatData
		pCCDcontrol->CAllocFlatData();
		SndMsg[0]=12464;
		OnSend(SndMsg);
		MsgFromMainCom.Format(_T("Alloc FlatData Array."));
		pprintEdit->InsertString(-1, MsgFromMainCom);
		pprintEdit->SetCurSel(pprintEdit->GetCount()-1);
	}
	else if(*intRecvBuffer==12465){//CoolerOn
		SndMsg[1]=pCCDcontrol->CoolerOnW();
		SndMsg[0]=12465;
		OnSend(SndMsg);
		MsgFromMainCom.Format(_T("CoolerOn"));
		pprintEdit->InsertString(-1, MsgFromMainCom);
		pprintEdit->SetCurSel(pprintEdit->GetCount()-1);
	}
	else if(*intRecvBuffer==12466){//CoolerOff
		SndMsg[1]=pCCDcontrol->CoolerOffW();
		SndMsg[0]=12466;
		OnSend(SndMsg);
		MsgFromMainCom.Format(_T("CoolerOff"));
		pprintEdit->InsertString(-1, MsgFromMainCom);
		pprintEdit->SetCurSel(pprintEdit->GetCount()-1);
	}
	else if(*intRecvBuffer==12467){//SetTemperature
		SndMsg[1]=pCCDcontrol->SetTemperatureW(*(intRecvBuffer+1));
		SndMsg[0]=12467;
		OnSend(SndMsg);
		MsgFromMainCom.Format(_T("SetTemperature.:%d"), (*(intRecvBuffer+1)) );
		pprintEdit->InsertString(-1, MsgFromMainCom);
		pprintEdit->SetCurSel(pprintEdit->GetCount()-1);
	}
	else if(*intRecvBuffer==12468){//GetTemperature
		int Temperature=0;
		SndMsg[1]=pCCDcontrol->GetTemperatureW(&Temperature);
		SndMsg[0]=12468;
		SndMsg[2]=Temperature;
		OnSend(SndMsg);
		MsgFromMainCom.Format(_T("Get Temp. Temp is %d"), Temperature);
		pprintEdit->InsertString(-1, MsgFromMainCom);
		pprintEdit->SetCurSel(pprintEdit->GetCount()-1);

	}
	else if(*intRecvBuffer==12469){//SetCameraParam
		pCCDcontrol->m_readmode	=*(intRecvBuffer+1);
		pCCDcontrol->m_trigger	=*(intRecvBuffer+2);
		
		SndMsg[0]=12469;
		OnSend(SndMsg);
		pCCDcontrol->SetCameraParamW();
		MsgFromMainCom.Format(_T("Set CameraParamW"));
		pprintEdit->InsertString(-1, MsgFromMainCom);
		pprintEdit->SetCurSel(pprintEdit->GetCount()-1);
	}
	else if(*intRecvBuffer==12470){//QuitCamera
		pCCDcontrol->QuitCamera();
		SndMsg[0]=12470;
		OnSend(SndMsg);
		MsgFromMainCom.Format(_T("Close CameraW"));
		pprintEdit->InsertString(-1, MsgFromMainCom);
		pprintEdit->SetCurSel(pprintEdit->GetCount()-1);
	}
	else if(*intRecvBuffer==12471){//getcamerainfo
		SndMsg[0]=12471;
		OnSend(SndMsg);
		pCCDcontrol->GetCameraInfo();
		
	}
	else if(*intRecvBuffer==12472){//Settakevariable.
		//SndMsg[0]=12472;
		//OnSend(SndMsg);
		pCCDcontrol->m_take=*(intRecvBuffer+1);
		pCCDcontrol->m_Scanpos_CCDframe=*(intRecvBuffer+2);

		//MsgFromMainCom.Format(_T("Take Frame : %d, Take: %d, fiss_take_mode :%d"), pCCDcontrol->m_Scanpos_CCDframe, *(intRecvBuffer+1), pCCDcontrol->m_fiss_take_mode);
		//pprintEdit->InsertString(-1, MsgFromMainCom);
		//pprintEdit->SetCurSel(pprintEdit->GetCount()-1);
		
	}
	else if(*intRecvBuffer==12473){//fiss_take_mode
		//SndMsg[0]=12473;
		//OnSend(SndMsg);
		pCCDcontrol->m_fiss_take_mode=*(intRecvBuffer+1);
		
	}
	else if(*intRecvBuffer==12474){//memset_RawData2
		int pixelnum=*(intRecvBuffer+1);
		//SndMsg[0]=12474;
		//OnSend(SndMsg);
		pCCDcontrol->memset_RawData2(pixelnum);
		
	}
	else if(*intRecvBuffer==12475){//memset_flatdata2
		int pixelnum=*(intRecvBuffer+1);
		//SndMsg[0]=12475;
		//OnSend(SndMsg);
		pCCDcontrol->memset_flatdata2(pixelnum);
		
	}
	else if(*intRecvBuffer==12476){//RunThread_stop
		//SndMsg[0]=12476;
		//OnSend(SndMsg);
		pCCDcontrol->m_Run_thread_stop=*(intRecvBuffer+1);
		
	}
	else if(*intRecvBuffer==12477){//FlatCalc
		SndMsg[0]=12477;
		OnSend(SndMsg);
		pCCDcontrol->Flat_Calc(*(intRecvBuffer+1));
		
	}
	else if(*intRecvBuffer==12478){//saveflatfits
		int num=*(intRecvBuffer+1);
		char * charRecvBuffer=(char * ) intRecvBuffer;
		char time1[50];
		char time2[50];
		sprintf(time1, charRecvBuffer+8);
		sprintf(time2, charRecvBuffer+58);
		SndMsg[0]=12478;
		OnSend(SndMsg);
		pCCDcontrol->SaveFlatFits(*(intRecvBuffer+1), time1, time2);
		
	}
	else if(*intRecvBuffer==12479){//displayCCDImage
		pCCDcontrol->DisplayCCDImage(*(intRecvBuffer+1));
		SndMsg[0]=12479;
		OnSend(SndMsg);
	}

	
	else if(*intRecvBuffer==12480){//SaveFits
		
		//SndMsg[0]=12480;
		//OnSend(SndMsg);
		int number		=*(intRecvBuffer+1);
		pCCDcontrol->SaveFits(number);
		MsgFromMainCom.Format(_T("SavefitsW:%s"), pCCDcontrol->entire_directory);
		pprintEdit->InsertString(-1, MsgFromMainCom);
		pprintEdit->SetCurSel(pprintEdit->GetCount()-1);
	}
	
	else if(*intRecvBuffer==12481){
		SndMsg[0]=12481;
		OnSend(SndMsg);
		pCCDcontrol->m_scan_size		=(float)		*(intRecvBuffer+1);
		pCCDcontrol->m_Scanner_status	=				*(intRecvBuffer+2);
		pCCDcontrol->m_scan_mode		=				*(intRecvBuffer+3);
		pCCDcontrol->m_scan_duration	=(float)		*(intRecvBuffer+4);
		pCCDcontrol->m_scan_speed		=(float)		*(intRecvBuffer+5);
		pCCDcontrol->m_scan_stroke		=(float)		*(intRecvBuffer+6);
	}
	else if(*intRecvBuffer==12482){
		SndMsg[0]=12482;
		OnSend(SndMsg);
		pCCDcontrol->m_solarxpos		=				*(intRecvBuffer+1);
		pCCDcontrol->m_solarypos		=				*(intRecvBuffer+2);
		pCCDcontrol->m_ringvalue		=				*(intRecvBuffer+3);
		sprintf(pCCDcontrol->m_Observer_name, (char*)(intRecvBuffer+4));
		sprintf(pCCDcontrol->m_AR_number	, (char*)(intRecvBuffer+4)+50);
	}
	
	else {
		MsgFromMainCom.Format(_T("RecvBufErr : %d"), *intRecvBuffer);
		pprintEdit->InsertString(-1, MsgFromMainCom);
		pprintEdit->SetCurSel(pprintEdit->GetCount()-1);
	}




	
//	⿡ process ͵  Ѵ. ޽   ؾ  ϵ.
	//if(MsgFromMainCom == "Grab\n")AfxMessageBox(_T("Grab"));
	//else AfxMessageBox(_T("NoGrab"));

}

void LanComm::ProcessClose(void)
{
	m_pServiceSocket->Close();
	delete m_pServiceSocket;

}

void LanComm::OnSend(int * SndBuffer)
{
//	MsgFromMainCom.Format(_T("Out_Msg:%d, %d, %d, %d"), SndBuffer[0], SndBuffer[1],
//						SndBuffer[2], SndBuffer[3]);
//	pprintEdit->InsertString(-1, MsgFromMainCom);
//	pprintEdit->SetCurSel(pprintEdit->GetCount()-1);

	m_pServiceSocket->Send(SndBuffer, sizeof(int)*10);
}

int LanComm::InitLanComm(CandorCCD * CCDcontrol, CListBox * printEdit)
{
	UINT nPort=1983;

	m_pListenSocket=new CListenSocket();
	m_pListenSocket->InitCListenSocket(this);
	
	//CCDControlԼ  
	pCCDcontrol=CCDcontrol;
	pprintEdit=printEdit;

	if(!m_pListenSocket->Create(nPort)){
		return 16001;
	}

	if(!m_pListenSocket->Listen()){
		return 16002;
	}
	return 1;
}