#pragma once

#define LE_HIDE 0

#include "cxcore.h"
#include "cv.h"
#include "highgui.h"

class CandorCCD
{
public:
	CandorCCD();

public:
	long m_totalCameras;
	long m_cameraHandle;
	long m_cameraIndex;
	int m_xpixels, m_ypixels;//real size of CCD chip
	float m_VSspeed, m_HSspeed;
	int m_VSnumber, m_HSnumber;
	int m_VSindex, m_HSindex;
	int m_ADnumber;
	int m_AMPnumber;
	int m_PAGnumber;
	float m_PreAmpGain;
	int m_IsPAGavailable;
	int m_minTemp, m_maxTemp;
	int m_setTemp;
	int m_hBin, m_vBin, m_hStart, m_hEnd, m_vStart, m_vEnd;
	float m_exptime;
	int m_readmode;
	int m_acquisition;
	int m_shutter;
	int m_fan;
	int m_status;
	int m_trigger;
	int m_nhDim, m_nvDim;	//image dimension
	int m_BitDepth;
	int m_nFrame;
	int m_gain;
	

	IplImage *				IplData;
	int m_ccdisworking;


	char entire_directory[250];
	char data_directory[30];
	WORD	*	BiasDark2;  
	WORD	*	g_pRawData2;	
	WORD	*	g_pImgData2;
	float	*	flatdata2;
	float	*	flatcube2;
	float	*	caldata2;
	struct tm *systime;
	int			m_take;
	int			m_Scanpos_CCDframe;
	int			m_fiss_take_mode;
	int			m_Run_thread_stop;
	
	int			m_ccd_camera;
	int			m_ringvalue;
	LARGE_INTEGER gliFreq, gliStart, gliEnd; 
	int			m_sequentialnumber;
	//int			m_scanner_InPosition;
	char		m_starttime1[50];
	char		m_endtime1[50];
	int			m_nBytePerPixel;

	float		m_scan_size,m_scan_duration, m_scan_speed, m_scan_stroke;
	int			m_Scanner_status, m_scan_mode;
	char		m_Observer_name[50], m_AR_number[50];
	int			m_solarxpos;
	int			m_solarypos;


public:
	void GetCameraInfo(void);
	int InitAndor(int acquisition, int Temp, int gain, 
							int HBin, int VBin, 
							float exptime, int shutter, int fan);

	int AcquisitionCL(WORD * Data, long Imsize);
	int GetAcquiredData16CL(WORD * Data, long Imsize);
	int AndorDone(int arg_c, void * arg_v[]);
	IplImage * WORD2IplImage(WORD * pImage, int xdimension, int ydimension);
	int Setting(int acquisition, int Temp, int gain, 
							int hBin, int vBin, 
							float exptime, int shutter, int fan);
	int GrabImage(void);
	int SaveFits( int number);//, int scansize, int Scanner_status, 
										//int scanmode, int scan_duration, int scan_speed, int scan_Stroke );

	int GrabnFrame(int nFrameNumber);
	int DestroyCCD();
	int LanGetAvailableCameras(void);
	int makefolderscript(char* path);
	int SetOkButton_FirstPart(int ccd_camera, int ringvalue, int ccd_Acquisition,
						   int ccd_Read, int ccd_Trigger, int ccd_Gain, int ccd_HBin, int ccd_VBin, float g_fExpTime1, 
						   int ccd_Shutter, int ccd_Fan,int g_nFrameNumber1);
	int CAllocFlatData(void);
	int	CoolerOnW(void);
	int CoolerOffW(void);
	int SetTemperatureW(int Temp);
	int GetTemperatureW(int * Temp);
	int TakeBiasDark(void);
	int SetCameraParamW(void);
	int SaveBiasDark(int nWidth, int nHeight, int number, float exptime);
	void QuitCamera(void);
	int TakingFlat(void);
	int TakeVariableSet(int take, int Scanpos_CCDframe);
	int	memset_RawData2(int pixelnum);
	int memset_flatdata2(int pixelnum);
	int fiss_take_mode(int fiss_take_mode);
	int Flat_Calc(int ii);
	int SaveFlatFits(int number, char * time1, char * time2);
	int DisplayCCDImage(int num);
	void marktime_start(char* timestring);
	void marktime_end(char* timestring);
	float time_difference();
	void DataDump(int nWidth, int nHeight, int i);
	void TakeImage(int nWidth, int nHeight,  int i);

};


/*
extern "C" __declspec(dllexport) int InitAndorOVRD(int arg_c, void * arg_v[]);
extern "C" __declspec(dllexport) int AcquisitionOVRD(int arg_c, void * arg_v[]);
*/